//2_ChangerPolicesStyles_203d.js
// 28.01.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Sert  modifier les polices des styles de paragraphes et de caractres

if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.");
	exit();
}

var curDoc = app.documents[0];

// mettre le contenu du bloc avec les styles de paragraphes 
// dans la variable 'paraStory'
try {
	var paraStory = curDoc.textFrames.item("paraStyles").parentStory;
	var nParas = paraStory.paragraphs.length;
}
catch (e) {
	alert ("Le bloc contenant les modles\ndes styles est introuvable.");
	exit();
}

// tester, s'il y a encore des polices manquantes dans le document
try {
	dfList = curDoc.fonts;
}
catch (e) {
}
var nFonts = dfList.length;
var curStatus;
var okay = true;
for (var i=0; i<nFonts; i++) {
	curStatus = dfList[i].status;
	if (curStatus == 1718832705) {
		okay = false;
		break;
	}
}
if (!okay) {
	var userDec = confirm ("Continuer?\n\nIl y a des polices manquantes!");
	if (userDec == false) {
		exit();
	}
}

// une boucle au travers les paragraphes
var paraFont;
var paraStyle;
for (var i=0; i<nParas; i++) {
	try {
		paraFont = paraStory.paragraphs[i].characters[-2].appliedFont.name;
		paraStyle = paraStory.paragraphs[i].appliedParagraphStyle;
		paraStyle.appliedFont = paraFont;
	}
	catch (e) {
	}
}

// mettre le contenu du bloc avec les styles de caractres 
// dans la variable 'charStory'
try {
	var charStory = curDoc.textFrames.item("charStyles").parentStory;
	var nChars = charStory.paragraphs.length;

	// une boucle au travers les paragraphes
	var charFont;
	var charStyle;
	for (var i=0; i<nChars; i++) {
		try {
			charFont = charStory.paragraphs[i].characters[-2].appliedFont.name;
			charStyle = charStory.paragraphs[i].characters[-2].appliedCharacterStyle;
			charStyle.appliedFont = charFont;
		}
		catch (e) {
		}
	}
}
catch (e) {
}

// supprimer les blocs
try {
	curDoc.textFrames.item("paraStyles").remove();
}
catch (e) {
}
try {
	curDoc.textFrames.item("charStyles").remove();
}
catch (e) {
}

alert ("Termin.", " ");